# CertManagerResourceApi

All URIs are relative to *https://localhost/api/v40*

Method | HTTP request | Description
------------- | ------------- | -------------
[**generateCertificate**](CertManagerResourceApi.md#generateCertificate) | **POST** /certs/generateCertificate | Exchange a cert request token for a certificate.


<a name="generateCertificate"></a>
# **generateCertificate**
> generateCertificate(body)

Exchange a cert request token for a certificate.

Exchange a cert request token for a certificate. The token must be a valid token generated by the certmanager utility. The resulting certificate will containin a TLS certificate in JKS and PEM formats. It might optionally contain a private key in JKS and PEM format, corresponding to the certificate.  The tar file is designed to be consumed by the \"cm install_certs\" command to install TLS certificates on a Cloudera Manager agent host.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.CertManagerResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

CertManagerResourceApi apiInstance = new CertManagerResourceApi();
ApiCertificateRequest body = new ApiCertificateRequest(); // ApiCertificateRequest | 
try {
    apiInstance.generateCertificate(body);
} catch (ApiException e) {
    System.err.println("Exception when calling CertManagerResourceApi#generateCertificate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiCertificateRequest**](ApiCertificateRequest.md)|  | [optional]

### Return type

null (empty response body)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/octet-stream

