# cm_client.CertManagerResourceApi

All URIs are relative to *https://localhost/api/v40*

Method | HTTP request | Description
------------- | ------------- | -------------
[**generate_certificate**](CertManagerResourceApi.md#generate_certificate) | **POST** /certs/generateCertificate | Exchange a cert request token for a certificate.


<a name="generate_certificate" id="generate_certificate"></a>
# **generate_certificate**
> generate_certificate(body=body)

Exchange a cert request token for a certificate.

Exchange a cert request token for a certificate. The token must be a valid token generated by the certmanager utility. The resulting certificate will containin a TLS certificate in JKS and PEM formats. It might optionally contain a private key in JKS and PEM format, corresponding to the certificate.  The tar file is designed to be consumed by the \"cm install_certs\" command to install TLS certificates on a Cloudera Manager agent host.

### Example
```python
from __future__ import print_function
import time
import cm_client
from cm_client.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: basic
configuration = cm_client.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = cm_client.CertManagerResourceApi(cm_client.ApiClient(configuration))
body = cm_client.ApiCertificateRequest() # ApiCertificateRequest |  (optional)

try:
    # Exchange a cert request token for a certificate.
    api_instance.generate_certificate(body=body)
except ApiException as e:
    print("Exception when calling CertManagerResourceApi->generate_certificate: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiCertificateRequest**](ApiCertificateRequest.md)|  | [optional] 

### Return type

void (empty response body)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/octet-stream

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

